#include <math.h>
#include <stdio.h>
#include <unistd.h>
#include <SDL/SDL.h>
#include "ZeDemo.h"
#include "precalcs.h"
#include "engine3d.h"
#include "effects.h"
#include "sound.h"

#undef main

SDL_Surface *screen;
SDL_Joystick *joy;
SDL_Event event;

int quit = 0;
int fullscreen = 0;

int fps_show=0;

int nfrm=0, pfrm=0;
int fps=0, atime=0;
int partime=0, prticks=0;
char sbuffer[64];

int part = 0;
int nparts = 5;

extern int objshow_num, objshow_rmode, objshow_shade;
int maxobj = 7, maxshade = 13;
int rmode = 3;

extern unsigned short shades[64][256];
extern int render_shit;

extern unsigned short loading[];

void Wait(int seconds)
{
    int atime = SDL_GetTicks();
    while(SDL_GetTicks() - atime < (seconds * 1000)){};
}

void exit2menu()
{
    SoundEnd();
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
}

int vol = 32;
int voladd = 16;

void CheckJoy()
{
	while (SDL_PollEvent(&event))
	{
		switch (event.type) 
		{
        case SDL_JOYBUTTONDOWN:
            switch(event.jbutton.button)
            {
                case GP2X_BUTTON_B:
                    fps_show = (fps_show+1) & 1;
                    break;

                case GP2X_BUTTON_START:
                    quit = 1;
                    break;
            }
        	break;
		}
	}
}


void ClearScreen()
{
    memset((unsigned int*)screen->pixels, 0, sizeof(unsigned short) * SSIZE);
}

void Script()
{
    unsigned short *vram = (unsigned short*)screen->pixels;

    prticks = SDL_GetTicks() - partime;
    int leblast = 2080;

	switch(part)
	{
		case 0:
            Floor(vram, 64, 64);
            objshow_num = 0;
            objshow_shade = 1;
            objshow_rmode = GOURAUD;
            render_shit = 0;
			RunScene3d(vram,0);
			if (prticks>leblast*6)
            {
                part = 1;
            }
		break;

        case 1:
			Radial(vram,1);
			if (prticks>leblast*12) part = 2;
		break;

		case 2:
            DrawSky(vram);
            objshow_num = 1;
            objshow_shade = 1;
            objshow_rmode = ENVMAP;
            render_shit = 0;
			RunScene3d(vram,1);
			if (prticks>leblast*24) part = 3;
		break;

		case 3:
            Polarplasma(vram, shades[4]);
            objshow_num = 2;
            objshow_shade = 6;
            objshow_rmode = GOURAUD;
            render_shit = 0;
			RunScene3d(vram,0);
			if (prticks>leblast*36) part = 4;
		break;

		case 4:
            Plasma(vram, shades[5]);
            objshow_num = 3;
            objshow_shade = 2;
            objshow_rmode = GOURAUD;
            render_shit = 0;
			RunScene3d(vram,0);
			if (prticks>leblast*48) part = 5;
		break;

		case 5:
            ClearScreen();
            objshow_num = 6;
            render_shit = 1;
			RunScene3d(vram,0);
			if (prticks>leblast*60)
			{
                InitRadialBitmap2();
                part = 6;
            }
		break;

		case 6:
			Radial(vram,0);
			if (prticks>leblast*71) quit = 1;
		break;

		default:
		break;
	}
}

/*
void hw_set_cpu(int speed)
{
	int m = 0;
	// Calculating the FPLL value from frequency is a bit complex
	// so we just use some known-to-work values instead.
	switch(speed)
	{
	case 250: m = 0x5D04; break;
	case 225: m =  0x5304; break;
	case 200: m = 0x4904; break;
	case 175: m = 0x3F04; break;
	case 150: m = 0x4901; break;
	case 125: m = 0x3c01; break;
	case 100: m = 0x6502; break;
	case 75: m = 0x4902; break;
	case 50: m = 0x6503; break;
	}

	if(m)
	{
		// Get interupt flags
		unsigned int l = memregs32[0x808>>2];

		// Turn off interrupts
		memregs32[0x808>>2] = 0xFF8FFFE7;

		// Set new clock frequency
		memregs16[0x910>>1]=m;

		// Wait for it to take
		while(memregs16[0x0902>>1] & 1);

		// Turn on interrupts again
		memregs32[0x808>>2] = l;
	}
}
*/

void Init()
{
//    hw_set_cpu(250);

	if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_AUDIO | SDL_INIT_JOYSTICK) < 0) 
    	exit2menu();

	screen = SDL_SetVideoMode(WIDTH, HEIGHT, 16, SDL_SWSURFACE);
	if (!screen)
        exit2menu();

    if (SDL_NumJoysticks() > 0)
		joy = SDL_JoystickOpen(0);

    SDL_WM_SetCaption ("Creep Tea by Optimus", 0);
	SDL_ShowCursor(SDL_DISABLE);

    SDL_LockSurface(screen);
    int i;
    unsigned short *vram = (unsigned short*)screen->pixels;
    for (i = 0; i<SSIZE; i++)
        *(vram+i) = loading[i];
    SDL_UnlockSurface(screen);
    SDL_Flip(screen);
//    Wait(5);

    precalcs();
    SoundInit();

    partime = SDL_GetTicks();
}

void CountFps()
{
	if (SDL_GetTicks()-atime>=1000)
	{
		atime = SDL_GetTicks();
		fps=(nfrm-pfrm);
		pfrm=nfrm;
	}

    if (fps_show==1)
    {
    	sprintf(sbuffer, "FPS = %d", fps);
        DrawText_(8, 16, 16, sbuffer, 16, (unsigned short*)screen->pixels);
    }
}


int main(int argc, char *argv[])
{
    if (argv[1]) fullscreen = SDL_FULLSCREEN;
    Init();

	do{
        SDL_LockSurface(screen);
    	Script();
    	CountFps();
    	nfrm++;
        SDL_UnlockSurface(screen);

        SDL_Flip(screen);
//        PlaySong();

    	CheckJoy();
	}while(!quit);

    SoundEnd();
    SDL_Quit();
	exit2menu();
	return 0;
}
